/*
    This program shows that some compilers initialize the local
    storage in a stack frame, even though that is not part of
    the definition of the C language. If the stack frame is not
    initialized, then the local variable x in test() will act
    like a static local variable, i.e., it will remember its
    last value.
*/
#include <stdio.h>

void test()
{
   int x;
   printf("%d\n", x++);
}

int main()
{
   int i;
   for(i = 0; i < 10; i++)
      test(); // calls to test() will reuse the same stack frame

   return 0;
}
