/*
    This program demonstrates several correct, and subtly
    different, ways to define a string, and two wrong ways.

    Look at the assembly language listing to see how the
    C compiler treats strings s2 and s3 differently.

    Each of the correct declarations has its advantages and
    its disadvantages.
*/
#include <stdio.h>

int main()
{
   char  s1[4] = "ball"; // wrong
   char *s2    = "bull";
   char  s3[5] = "bell";
   char  s4[]  = "bill";
   char  s5[4] = {'b', 'a', 'l', 'l'};       // not a string
   char  s7[5] = {'b', 'e', 'l', 'l', '\0'}; // same as s3
   char  s8[]  = {'b', 'i', 'l', 'l', '\0'}; // same as s4


   printf("%s\n", s1);
   printf("%s\n", s2);
   printf("%s\n", s3);
   printf("%s\n", s4);
   printf("%s\n", s5);
   printf("%s\n", s7);
   printf("%s\n", s8);


   s1[0] = 'C';  // change a letter in the string
   s2[0] = 'C';  // change a letter in the string
   s3[0] = 'C';  // change a letter in the string
   s4[0] = 'C';  // change a letter in the string
   s5[0] = 'C';  // change a letter in the string
   s7[0] = 'C';  // change a letter in the string
   s8[0] = 'C';  // change a letter in the string


   printf("%s\n", s1);
   printf("%s\n", s2);
   printf("%s\n", s3);
   printf("%s\n", s4);
   printf("%s\n", s5);
   printf("%s\n", s7);
   printf("%s\n", s8);

   return 0;
}
