/*
    This program demonstrates a few different calling conventions
    supported by Microsoft's version of C (but lcc only supports
    two of the three calling conventions).

    Look at the assembly listing for this code to see how the calling
    conventions differ. Also, see the online MSDN documentation at

    http://msdn.microsoft.com/en-us/library/aa235575(VS.60).aspx

    and

    http://msdn.microsoft.com/en-us/library/984x0h58.aspx
*/
#include <stdio.h>

// Look at the assembly language listing to see how each
// of the following three function definitions differ.
int test_function1(int i, int j)
{
   return i+j;
}

int __stdcall test_function2(int i, int j)
{
   return i+j;
}

int __fastcall test_function3(int i, int j)
{
   return i+j;
}

int main()
{
   int x = 2;
   int y = 3;
   // Look at the assembly language listing to see how each
   // of the following three function calls differ.
   test_function1(x, y);
   test_function2(x, y);
   test_function3(x, y);
   return 0;
}
